;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; 04_critical_section.lisp - Kritická sekce
;;;

;;
;; Úprava speciálního operátoru assert
;;

;; Zařídíme, aby se podmínka v assert vyhodnocovala atomicky.
(execute '(:split :drop :dup eval :val
           :a? :if :aon :clsub :aoff :else :clsub :then
           :if :assert-error :else :drop nil :then :ret) 'assert :set!)


;;
;; Příkaz test-and-set
;;

;; Syntax: (ts var) 
;; Atomicky nastaví var na t a vrátí původní hodnotu var.
(evaluate '(set! specials (cons 'ts specials)))
(execute '(:split :drop     ; var
           :aon 
             :dup :val :swap ; var val
             t :swap :set! :drop ; val
           :aoff
           :ret
           ) 'ts :bind)


;; Řešení kritické sekce pomocí test-and-set:
#|
;; Scheme

(let ((n 0) 
      (lock nil))
  (co
   (dotimes (i 50)
     (while (ts lock)
            nil)
     (set! n (+ n 1))
     (set! lock nil))
   (dotimes (i 50)
     (while (ts lock)
            nil)
     (set! n (+ n 1))
     (set! lock nil)))
  n)
|#